
host_ip='0.0.0.0'
port='8080'
fullscreen_on=false
table.chat_message=''

--  
---------------
Menu = {}
Menu.__index = Menu
function Menu.create()
	local temp = {}
	setmetatable(temp, Menu)
	temp.button = {	start = Button.create(graphics.play_button,465,290,151, 75,      0, 0, 0,2),
					rules = Button.create(graphics.rules_button,450,377,189,72,      20, 0, 4,0),
					settings = Button.create(graphics.options_button,397,450,190,76, 85, -3, 12,2),
					credits = Button.create(graphics.credits_button,410,532,190,72,  70, 0, 10,0),
					quit = Button.create(graphics.quit_button,465,607,144,74,        0, 0, -1,0)
					}
	return temp
end

function Menu:draw()

love.graphics.setScissor()
   love.graphics.draw(graphics.back,0,0,0,1,1,100,75)
   love.graphics.draw(graphics.menu_main,-110,-150,0,1,1,0,0)

	for n,b in pairs(self.button) do
		b:draw(b.img,b.x,b.y)
	end


end

function Menu:update(dt)

	for n,b in pairs(self.button) do
		b:update(dt)
	end


end

function Menu:mousepressed(x,y,button)

	for n,b in pairs(self.button) do
		if b:mousepressed(x,y,button) then
			if n == "start" then
				state = GameOptions.create()
			elseif n == "rules" then
				state = Rules.create()
			elseif n == "settings" then
				state = Settings.create()
			elseif n == "credits" then
				state = Credits.create()
			elseif n == "quit" then
				love.event.push("q")
			end
		end
	end

end

function Menu:keypressed(key)

	if key == "escape" then
		love.event.push("q")
	end

end

--  
---------------
Rules = {}
Rules.__index = Rules
function Rules.create()
	local temp = {}
	setmetatable(temp, Rules)
	temp.delta=0
	temp.button = {back = Button.create(graphics.back_button,30,660,90,86,               0, -16, -8, 0) }
	return temp
end

function Rules:draw()

function scroll(d)
	love.graphics.draw(graphics.rules_text,310,120-d,0,1,1,100,75)
end

	love.graphics.draw(graphics.back,0,0,0,1,1,100,75)
	love.graphics.draw(graphics.menu_rules,-350,-405)
    love.graphics.setScissor(100,40,900,680)
    scroll(self.delta)
	love.graphics.setScissor()
	for n,b in pairs(self.button) do
	b:draw(b.img,b.x,b.y)
	end

end

function Rules:update(dt)

	for n,b in pairs(self.button) do
		b:update(dt)
	end

end

function Rules:mousepressed(x,y,button)

	for n,b in pairs(self.button) do
		if b:mousepressed(x,y,button) then
			if n == "back" then
				state = Menu.create()
			end
		end
	end

	if button == "wd" then
		if self.delta < 2450 then
		self.delta=self.delta+20
		end
	elseif button == "wu" then
		if self.delta > 0 then
		self.delta=self.delta-20
		end
	end
end

function Rules:keypressed(key)
	if key == "escape" then
		state = Menu.create()
	elseif key == "down" then
		if self.delta < 2350 then
		self.delta=self.delta+20
		end
	elseif key == "up" then
		if self.delta > 0 then
		self.delta=self.delta-20
		end
	end

end


--  
-------------
Settings = {}
Settings.__index = Settings
function Settings.create()
	local temp = {}
	setmetatable(temp, Settings)
	temp.button =  {back = Button.create(graphics.back_button,30,650,90,86, 0, -16, -8, 0),
					full_left = Button.create(graphics.arrow_left_button,385,170,100,76,   10, 0, -15, -1),
					full_right = Button.create(graphics.arrow_right_button,655,170,100,76,   10, 0, -9, -1),
					port_input = Button.create(graphics.port_input,440,380,288,70,   0, 0, 17, 2),
					host_ip_input = Button.create(graphics.host_ip_input,208,590,730,72,   0, 0, 71, 2)
					}
	temp.port_input=port
	temp.host_ip_input=host_ip

	return temp
end

function Settings:draw()


local function port_input_text()
--   ,  
if port_input then
  host_ip_input=false
  function love.keypressed(key,unicode)
	if key=="kp1" then key="1" end
	if key=="kp2" then key="2" end
	if key=="kp3" then key="3" end
	if key=="kp4" then key="4" end
	if key=="kp5" then key="5" end
	if key=="kp6" then key="6" end
	if key=="kp7" then key="7" end
	if key=="kp8" then key="8" end
	if key=="kp9" then key="9" end
	if key=="kp0" then key="0" end
	if key=="kpenter" then key="return" end


	if key=="escape" then
		state=Menu.create()

    elseif key=="backspace" then
	self.port_input=self.port_input:sub(0,#self.port_input-1)

	elseif key=='1' or key=='2' or key=='3' or key=='4' or key=='5' or key=='6' or key=='7' or key=='8' or key=='9' or key=='0' then
	if #self.port_input<5 then
	self.port_input=self.port_input..key
	end
	end
  end

  port=self.port_input

end
end



	--    
local function print_port_input_text(x,y)
	love.graphics.setFont(font.chat_huge)
	love.graphics.printf(self.port_input,x,y,5,'center')
end




local function host_ip_input_text()
--   ,  
if host_ip_input then
  port_input=false
  function love.keypressed(key,unicode)
	if key=="kp1" then key="1" end
	if key=="kp2" then key="2" end
	if key=="kp3" then key="3" end
	if key=="kp4" then key="4" end
	if key=="kp5" then key="5" end
	if key=="kp6" then key="6" end
	if key=="kp7" then key="7" end
	if key=="kp8" then key="8" end
	if key=="kp9" then key="9" end
	if key=="kp0" then key="0" end
	if key=="kp." then key="." end
	if key=="kpenter" then key="return" end


	if key=="escape" then
		state=Menu.create()

    elseif key=="backspace" then
	self.host_ip_input=self.host_ip_input:sub(0,#self.host_ip_input-1)

	elseif key=='1' or key=='2' or key=='3' or key=='4' or key=='5' or key=='6' or key=='7' or key=='8' or key=='9' or key=='0' or key=='.' then
	if #self.host_ip_input<15 then
	self.host_ip_input=self.host_ip_input..key
	end
	end
  end

  host_ip=self.host_ip_input

end
end



--    
local function print_host_ip_input_text(x,y)
	love.graphics.setFont(font.chat_huge)
	love.graphics.printf(self.host_ip_input,x,y,#self.host_ip_input,'center')
end


	love.graphics.draw(graphics.back,0,0,0,1,1,0,75)
	love.graphics.draw(graphics.menu_rules,-350,-405)
	love.graphics.draw(graphics.fullscreen,400,80)--fullscreen 
	love.graphics.draw(graphics.connection_port,290,300)
	love.graphics.draw(graphics.host_ip,450,510)

	love.graphics.setFont(font.huge)
	if fullscreen_on then love.graphics.printf("On",575,230,2,'center') else love.graphics.printf("Off",575,230,2,'center') end


	for n,b in pairs(self.button) do
		b:draw(b.img, b.x, b.y)
	end




	port_input_text()
    love.graphics.setScissor(440,380,280,85)
	print_port_input_text(580,440)
	love.graphics.setScissor()

	host_ip_input_text()
	--love.graphics.setScissor(290,710,862,75)
	print_host_ip_input_text(565,650)
	--love.graphics.setScissor()

end

function Settings:update(dt)

	for n,b in pairs(self.button) do
		b:update(dt)
	end

end

function Settings:mousepressed(x,y,button)


	for n,b in pairs(self.button) do
	  if b:mousepressed(x,y,button) then
		if n=="full_left" then
			if fullscreen_on then
			  fullscreen_on=false
			  love.graphics.setMode(love.graphics.getWidth(), love.graphics.getHeight(), false)
			end
		end
		if n=="full_right" then
			if not fullscreen_on then
			  fullscreen_on=true
			  love.graphics.toggleFullscreen()
			end
		end
		if n == "back" then
			state = Menu.create()
		end
	  end
	end

end

function Settings:keypressed(key)

	if key == "escape" then
		state = Menu.create()
	end

end

-- 
---------
Game = {}
Game.__index = Game
function Game.create()
 temp = {}
	setmetatable(temp, Game)
	temp.balls_red={9,9,9,9,9,9,9,9,9}
    temp.balls_blue={9,9,9,9,9,9,9,9,9}
	temp.letters={'a','b','c','d','e','f','g','h','i'}

	temp.score_red=0
	temp.score_blue=0
	temp.units_blue=0
	temp.units_red=0
	temp.turn='blue'-- "",  ""

	temp.blue_tuzdik=false
	temp.red_tuzdik=false
	temp.text_input=''
	temp.winner=false
	temp.pause = false -- if the game is paused
	temp.button = {	resume = Button.create(graphics.resume_button, 400, 345, 272, 62,5,0, 12,0),
					quit = Button.create(graphics.quit_button,460,420,144,74,  0, 0, -1, 0),
					text_input = Button.create(graphics.text_input_border,560,708,370,35,  0, -25, 22, -2)
					}
	temp.holes_red =  {hole_red = Button.create(graphics.hole,50,180,90,90,0,0,0,0)}

	temp.holes_blue = {hole_blue_1 = Button.create(graphics.hole,50, 658,90,110, -15, 0, -6, 4),
					   hole_blue_2 = Button.create(graphics.hole,150,638,90,90, 0, -10, -6, 4),
					   hole_blue_3 = Button.create(graphics.hole,250,618,90,90, 0, -10, -6, 4),
					   hole_blue_4 = Button.create(graphics.hole,350,598,90,90, 0, -10, -6, 4),
					   hole_blue_5 = Button.create(graphics.hole,450,578,90,90, 0, -10, -6, 4),
					   hole_blue_6 = Button.create(graphics.hole,550,558,90,90, 0, -10, -6, 4),
					   hole_blue_7 = Button.create(graphics.hole,650,538,90,90, 0, -10, -6, 4),
					   hole_blue_8 = Button.create(graphics.hole,750,518,90,90, 0, -10, -6, 4),
					   hole_blue_9 = Button.create(graphics.hole,850,498,90,90, 0, -10, -6, 4)
					  }
  return temp
end

function Game:draw()

local function text_input()
--   ,  
if input then

  function love.keypressed(key,unicode)
	if key=="kp1" then key="1" end
	if key=="kp2" then key="2" end
	if key=="kp3" then key="3" end
	if key=="kp4" then key="4" end
	if key=="kp5" then key="5" end
	if key=="kp6" then key="6" end
	if key=="kp7" then key="7" end
	if key=="kp8" then key="8" end
	if key=="kp9" then key="9" end
	if key=="kp0" then key="0" end
	if key=="kpenter" then key="return" end
	if key=="kp+" then key="+" end
	if key=="kp-" then key="-" end
	if key=="kp*" then key="*" end
	if key=="kp/" then key="/" end
	if key=="kp." then key="." end

	if key=="escape" then
		if self.pause then
			self.pause = false
		else
			self.pause = true
		end

    elseif key=="backspace" then
	self.text_input=self.text_input:sub(0,#self.text_input-1)

	elseif key=="return" then
	table.chat_message=self.text_input
	print(table.chat_message)
	self.text_input=''
	table.chat_message=''
	elseif key~='tab' and key~='capslock' and key~='numlock' and key~='f1' and key~='f2' and key~='f3' and key~='f4' and key~='f5' and key~='f6'
	and key~='f7' and key~='f8' and key~='f9' and key~='f10' and key~='f11' and key~='f12' and key~='home' and key~='end' and key~='insert' and key~='lshift'
	and key~='rshift' and key~='lalt' and key~='ralt' and key~='lctrl' and key~='rctrl' and key~='scrollock' and key~='pageup' and key~='pagedown'
	and key~='delete' and key~='lsuper' and key~='print' and key~='pause' and key~='menu' then
	self.text_input=self.text_input..key
	end
  end


end
end



--    
local function print_text_input(x,y)
	love.graphics.setFont(font.chat)
	love.graphics.print(self.text_input,x,y)
end



love.graphics.draw(graphics.back,0,0,0,1,1,100,75)
love.graphics.draw(graphics.menu_chat,500,698)



--[[local function print_time()
love.graphics.setFont(font.large)
   love.graphics.printf(os.date():sub(10,14),1200,760,6,'center')
end]]




self.button.text_input:draw(graphics.text_input_border, 561, 710)----------     


-- 
	for n,b in pairs(self.holes_red) do
		for x=1,9 do
		b:draw(b.img,x*100-50,200-x*20)
		end
	end

	for n,b in pairs(self.holes_blue) do
		b:draw(b.img,b.x,b.y)
	end





-- ,    
local function draw_numbers()
 love.graphics.setFont(font["large"])
 for i,v in ipairs(temp.balls_red) do
   love.graphics.printf(v,((10-i)*100-50)+45,(200-(10-i)*20)+65,2,'center')  --   ,   i
 end
 for i,v in ipairs(temp.balls_blue) do
   love.graphics.printf(v,(i*100-50)+45,(678-i*20)+65,2,'center')
 end

 love.graphics.setFont(font["large"])
 --love.graphics.printf("Opponent:"..temp.score_red,690,450,10,'center')
 --love.graphics.printf("You:"..temp.score_blue,690,320,6,'center')
 --love.graphics.printf("Turn:" .. temp.turn,850,390,2,'center')

end






-- 
local function draw_letters()
 love.graphics.setFont(font.letters)
 for i,v in ipairs(self.letters) do
     love.graphics.printf(v,(10-i)*100-5,330-(10-i)*20,1,'center')
 end
 for i,v in ipairs(self.letters) do
   love.graphics.printf(v,(i*100-50)+45,(678-i*20)-10,1,'center')
 end
end





-------------------------------------- ,      
function user_click(pos,col)

    local num=col[pos]
	local delta=0
    local t=0

--    
	if num==0 then
       col[pos]=0
       zero=true

--  
    elseif num==1 then
       zero=false
	   col[pos]=0
        if pos==9 then
	        if col==temp.balls_red then col=temp.balls_blue else col=temp.balls_red end
			pos=1
        else
            pos=pos+1
        end
    col[pos]=col[pos]+1

--  
    else
		col[pos]=1
		zero=false
			for i=1,num-1 do
			    if pos+i-delta==10 then
			      if col==temp.balls_red then col=temp.balls_blue else col=temp.balls_red end
			      pos=1
			      delta=i
			    end
              col[pos+i-delta]=col[pos+i-delta]+1
			  t=i
			end
	end

--        
 if col[pos+t-delta]%2==0  then

      if temp.turn=='red' and col==temp.balls_blue then
        temp.score_red=temp.score_red+col[pos+t-delta]--   
	    col[pos+t-delta]=0
	  elseif temp.turn=='blue' and col==temp.balls_red then
	    temp.score_blue=temp.score_blue+col[pos+t-delta]--   
	    col[pos+t-delta]=0
	  end

-- 
  elseif col[pos+t-delta]==3 then

    if col==temp.balls_red and temp.turn=='blue' and pos+t-delta~=9 and pos+t-delta~=self.red_tuzdik and pos+t-delta~=self.blue_tuzdik then

	   if not self.blue_tuzdik then
	    if self.red_tuzdik then
			if self.blue_tuzdik~=self.red_tuzdik then self.blue_tuzdik=pos+t-delta end
	    else
			self.blue_tuzdik=pos+t-delta
		end
	   end

	elseif col==temp.balls_blue and temp.turn=='red' and pos+t-delta~=9 and pos+t-delta~=self.red_tuzdik and pos+t-delta~=self.blue_tuzdik then

		if not self.red_tuzdik then
		  if self.blue_tuzdik then
		    if self.blue_tuzdik~=self.red_tuzdik then self.red_tuzdik=pos+t-delta end
	    else
		    self.red_tuzdik=pos+t-delta
		  end
	   end

    end

 end

--  ,   
  if not zero then
	 print(self.turn .. " moves " ..num.. " balls from " .. self.letters[pos])
     if temp.turn=='red' then temp.turn='blue' else temp.turn='red' end
  end

--  ,       
  if self.red_tuzdik then
    self.score_red=self.score_red+self.balls_blue[self.red_tuzdik]
	self.balls_blue[self.red_tuzdik]=0
  end

  if self.blue_tuzdik then
    self.score_blue=self.score_blue+self.balls_red[self.blue_tuzdik]
	self.balls_red[self.blue_tuzdik]=0
  end

   draw_numbers()
   win_test()
end
--------------------- user_click

--  
----------------
self.units_blue=10*(self.score_blue)
self.units_red=10*(self.score_red)

love.graphics.setScissor(49,450,self.units_blue,50)
love.graphics.draw(graphics.unit,50,450)--  ()
love.graphics.setScissor()

love.graphics.setScissor(950-self.units_red,300,800,50)
love.graphics.draw(graphics.unit,224,300)-- 
love.graphics.setScissor()
---------------



  draw_numbers()
  draw_letters()
  --print_time()
  text_input()
  love.graphics.setScissor(561,710,366,35)
  print_text_input(563,734)
  love.graphics.setScissor()



--    
	if self.blue_tuzdik then
	  if 	  self.blue_tuzdik==1 then love.graphics.draw(graphics.hole_lastball,835,10)--'a'   ()
	  elseif  self.blue_tuzdik==2 then love.graphics.draw(graphics.hole_lastball,735,26)
	  elseif  self.blue_tuzdik==3 then love.graphics.draw(graphics.hole_lastball,635,50)
	  elseif  self.blue_tuzdik==4 then love.graphics.draw(graphics.hole_lastball,535,58)
	  elseif  self.blue_tuzdik==5 then love.graphics.draw(graphics.hole_lastball,435,90)
	  elseif  self.blue_tuzdik==6 then love.graphics.draw(graphics.hole_lastball,335,109)
	  elseif  self.blue_tuzdik==7 then love.graphics.draw(graphics.hole_lastball,235,130)
	  elseif  self.blue_tuzdik==8 then love.graphics.draw(graphics.hole_lastball,135,150)
	  elseif  self.blue_tuzdik==9 then love.graphics.draw(graphics.hole_lastball,35,170)
	  end
	end

	if self.red_tuzdik then
	  if 	  self.red_tuzdik==1 then love.graphics.draw(graphics.hole_lastball,35,647)--''  
	  elseif  self.red_tuzdik==2 then love.graphics.draw(graphics.hole_lastball,135,628)
	  elseif  self.red_tuzdik==3 then love.graphics.draw(graphics.hole_lastball,235,608)
	  elseif  self.red_tuzdik==4 then love.graphics.draw(graphics.hole_lastball,335,588)
	  elseif  self.red_tuzdik==5 then love.graphics.draw(graphics.hole_lastball,435,568)
	  elseif  self.red_tuzdik==6 then love.graphics.draw(graphics.hole_lastball,535,548)
	  elseif  self.red_tuzdik==7 then love.graphics.draw(graphics.hole_lastball,635,528)
	  elseif  self.red_tuzdik==8 then love.graphics.draw(graphics.hole_lastball,735,508)
	  elseif  self.red_tuzdik==9 then love.graphics.draw(graphics.hole_lastball,835,488)
	  end
	end






--
    if self.pause then
		love.graphics.draw(graphics.menu_pause,170,200)
		love.graphics.draw(graphics.pause,405,260)

		self.button["resume"]:draw(graphics.resume_button, 400, 345)
		self.button["quit"]:draw(graphics.quit_button, 460, 420)
	end







--!
	if self.winner then
		love.graphics.draw(graphics.menu_winner,-200,0)
		if temp.winner=='red' then
		love.graphics.printf("Game Over!", -150, 250, love.graphics.getWidth(), "center")
		else
		love.graphics.printf("Congratulations!", -150, 250, love.graphics.getWidth(), "center")
		end

		self.button["quit"]:draw(graphics.quit_button, 460, 420)
	end


end

function Game:update(dt)

self.button.text_input:update(dt)

-- ,     
function inside(a,b)
 if love.mouse.getX()>a and love.mouse.getX()<a+85 and love.mouse.getY()>b and love.mouse.getY()<b+85 then
  return true
 else
  return false
 end
end

	if self.pause then
		self.button["resume"]:update(dt)
		self.button["quit"]:update(dt)
	elseif self.winner then
		self.button["quit"]:update(dt)
	end

	if not self.pause then
	for n,b in pairs(self.holes_blue) do
		b:update(dt)
	end
	end

end

function Game:mousepressed(x, y, button)

self.button.text_input:mousepressed(x,y,button)

local function empty(tbl)
local s=0
 for i,v in ipairs(tbl) do
   s=s+v
 end

 if v==0 then
   return true
 else
   return false
 end

end

--  81   
function win_test()
 if temp.score_red>81 or empty(temp.balls_blue) then
  temp.winner='red'
 elseif temp.score_blue>81 or empty(temp.balls_red) then
   temp.winner='blue'
 end
end

--    
local function random_from_table(t)
 local rn=math.random(1,#t)
 return t[rn]
end


--        ...
local function findodd(col)
local arr={}
 for i,v in ipairs(col) do
   if v%2==1 then
     table.insert(arr,i,v)
   end
 end
 --table.sort(arr, function(a,b) return a>b end)
 return arr
end

--   ,    
local function look_to_make_turn(ind)
local possible_moves={}
 for i,v in ipairs(temp.balls_red) do
    if (v-1)==(9-i+ind) then
	   table.insert(possible_moves,i,v)
	end
 end
 --for i,v in pairs(possible_moves) do print(i,v) end
 return possible_moves
end

--main ai turn function
function bot_thinks()
 local odd_array=findodd(temp.balls_blue)--    ,    

  for i,v in pairs(odd_array) do
     local moves=look_to_make_turn(i)--  "- "    ,       i

	  if #moves>0 then
	    for index,balls in pairs(moves) do
	      user_click(index,temp.balls_red)
		  if temp.turn=='blue' then break end
		end
	  elseif #moves==0 then
		local non_zero={}
		  for i,v in pairs(temp.balls_red) do
			if v>0 then table.insert(non_zero,i) end
		  end
		rnd=random_from_table(non_zero)
	    user_click(rnd,temp.balls_red)
		if temp.turn=='blue' then break end
	  else
		print("???")
	  end
   if temp.turn=='blue' then break end
 end

end



--  
if self.pause then
		if self.button["resume"]:mousepressed(x, y, button) then
			self.pause = false
		elseif self.button["quit"]:mousepressed(x, y, button) then
			state = Menu.create()
		end
--  
elseif self.winner then
		if self.button["quit"]:mousepressed(x, y, button) then
			state = Menu.create()
		end
--
else
  if button=='l' and temp.turn=='blue' then

 if inside(50,658)  then
   user_click(1,temp.balls_blue)
   if bot then
       if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(150,638)  then
   user_click(2,temp.balls_blue)
   if bot then
       if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(250,618)  then
	user_click(3,temp.balls_blue)
	if bot then
	   if temp.turn=='red' then bot_thinks() end
	end

 elseif inside(350,598)  then
   user_click(4,temp.balls_blue)
   if bot then
	   if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(450,578)  then
   user_click(5,temp.balls_blue)
   if bot then
       if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(550,558)  then
   user_click(6,temp.balls_blue)
   if bot then
      if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(650,538)  then
   user_click(7,temp.balls_blue)
   if bot then
       if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(750,518)  then
   user_click(8,temp.balls_blue)
   if bot then
       if temp.turn=='red' then bot_thinks() end
   end

 elseif inside(850,498)  then
   user_click(9,temp.balls_blue)
   if bot then
   if temp.turn=='red' then bot_thinks() end
   end
  end

 end
end

end

function Game:keypressed(key)

	if key == "escape" then

		if self.pause then
			self.pause = false
		else
			self.pause = true
		end
	end

end






--  
----------------
GameOptions = {}
GameOptions.__index = GameOptions
function GameOptions.create()

    local temp = {}
	setmetatable(temp, GameOptions)
	temp.button = {	startsingle = Button.create(graphics.singame_button,295,330,380,75,    70, 0, 29, 2),
					startonline = Button.create(graphics.online_button,400,413,214,64,     5, 0, 6.5, 0),
					back = Button.create(graphics.back_button,30,650,90,86, 0, -16, -8, 0)}
	return temp
end

function GameOptions:draw()

love.graphics.draw(graphics.back,0,0,0,1,1,100,75)
love.graphics.draw(graphics.menu_play,80,360,0,1,1,100,75)

  for n,b in pairs(self.button) do
		b:draw(b.img, b.x, b.y)
	end

end

function GameOptions:update(dt)

for n,b in pairs(self.button) do
		b:update(dt)
	end

end

function GameOptions:mousepressed(x,y,button)


	for n,b in pairs(self.button) do
		if b:mousepressed(x,y,button) then
			if n == "startsingle" then
				bot=true
				state = Game.create()
			end
			if n == "startonline" then
				bot=false
				state=Online.create()
			end
			if n == "back" then
				state = Menu.create()
			end
		end
    end
end

function GameOptions:keypressed(key)

if key == "escape" then
		love.event.push("q")
	end

end





-- 
----------
Credits = {}
Credits.__index = Credits
function Credits.create()

	local temp = {}
	setmetatable(temp, Credits)
	temp.button = {back = Button.create(graphics.back_button,30,660,90,86, 0, -16, -8, 0) }
	return temp

end
function Credits:draw()

love.graphics.draw(graphics.back,0,0,0,1,1,100,75)

for n,b in pairs(self.button) do
		b:draw(b.img, b.x, b.y)
	end

end
function Credits:update(dt)

for n,b in pairs(self.button) do
		b:update(dt)
	end

end
function Credits:mousepressed(x,y,button)

	for n,b in pairs(self.button) do
		if b:mousepressed(x,y,button) then
			if n == "back" then
				state = Menu.create()
			end
		end
	end

end
function Credits:keypressed(key)

if key == "escape" then
		love.event.push("q")
	end

end

--  
-------
Online = {}
Online.__index = Online
function Online.create()

    local temp = {}
	setmetatable(temp, Online)
	temp.button = {	create_button = Button.create(graphics.create_button,560,430,228,62,    0, 0, 8, 0),
					connect_button = Button.create(graphics.connect_button,540,513,280,62,     0, 0, 12, 0.5),
					back = Button.create(graphics.back_button,30,650,90,86, 0, -16, -8, 0)
					}
	return temp
end

function Online:draw()

love.graphics.draw(graphics.back,0,0,0,1,1,100,75)
love.graphics.draw(graphics.menu_play,250,460,0,1,1,100,75)

  for n,b in pairs(self.button) do
		b:draw(b.img, b.x, b.y)
	end

end

function Online:update(dt)

for n,b in pairs(self.button) do
		b:update(dt)
	end

end

function Online:mousepressed(x,y,button)




-- 
local function server(ip,p)
  print(ip,port)
  local host = ip or 'localhost'
  local port = p
print("Binding to host '" ..host.. "' and port " ..port.. "...")
  local s = assert(socket.bind(host, port))-- 
  local i, p   = s:getsockname()-- ip   
assert(i, p)
print("Waiting connection from talker on " .. i .. ":" .. p .. "...")
local c = assert(s:accept())--        
print("Connected. Here is the stuff:")
local l, e = c:receive()
while l do
	print(l)
	l, e = c:receive()
end
print(e)
end




-- 
local function client(ip,p)

 local host = ip
 local port = p

print("Attempting connection to host '" ..host.. "' and port " ..port.. "...")
 local c = assert(socket.connect(host, port))
print("Connected! Please type stuff (empty line to stop):")
 local l='Hello!'
while l and l~='' and not e do
	assert(c:send(l .. "\n"))
	l = table.chat_message
end

end




	for n,b in pairs(self.button) do
		if b:mousepressed(x,y,button) then
			if n == "create_button" then
				state=Game.create()
				server('192.168.1.5',port)
				client('192.168.1.5',port)
			end
			if n == "connect_button" then
				state=Game.create()
				client(host_ip,port)
			end
			if n == "back" then
				state = GameOptions.create()
			end
		end
    end
end

function Online:keypressed(key)

    if key == "escape" then
		love.event.push("q")
	end

end
